#include <stdio.h>
#include <stdlib.h>
#include "bmp.h"


BMP * bmpCreate( unsigned int linhas, unsigned int colunas)
{
	BMP * result;
	unsigned int size;

	size = (3 * colunas + 3)/4*4 * linhas + sizeof(BITMAPFILEHEADER)+ sizeof(BITMAPINFOHEADER);

	result = (BMP*) malloc(size);

	result->fileHeader.bfType[0]='B';
	result->fileHeader.bfType[1]='M';
	result->fileHeader.bfSize= size;
	result->fileHeader.bfReserved1 = result->fileHeader.bfReserved2=0;
	result->fileHeader.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	result->infoHeader.biSize = sizeof(BITMAPINFOHEADER);
	result->infoHeader.biWidth = colunas;
	result->infoHeader.biHeight = linhas;
	result->infoHeader.biPlanes = 1;
	result->infoHeader.biBitCount = 24;
	result->infoHeader.biCompression=0;
	result->infoHeader.biSizeImage = size - result->fileHeader.bfOffBits;

	return result;
}

int bmpSave (BMP *bmp, char * filename)
{
	FILE * outfile;

	if ((outfile=fopen(filename, "wb")) == NULL)
	{
		perror(filename);
		return 0;
	}
	fwrite(bmp, bmp->fileHeader.bfSize,1, outfile);
	fclose(outfile);
	return 1;
}

RGB * getLineStart( BMP *bmp, unsigned int linha)
{
	return  (RGB * )((char *)bmp + (3 * bmp->infoHeader.biWidth + 3)/4*4 * linha + sizeof(BITMAPFILEHEADER)+ sizeof(BITMAPINFOHEADER));
}