// lixo20.cpp : Defines the entry point for the console application.
//

#include <stdlib.h>
#include <stdio.h>
#include "bmp.h"
#include "mandelbrot.h"






RGB palette[] = {
	{0xff,0xff,0xff},{0xef,0xff,0xff},{0xff,0xef,0xff},{0xff,0xff,0xef},
	{0x80,0xff,0xff},{0xef,0xff,0xff},{0xff,0xef,0xff},{0xff,0xff,0xef},
	{0xff,0xff,0xff},{0xef,0x9f,0x00},{0xff,0x7f,0xff},{0xff,0xff,0xef},
	{0xf0,0xff,0x6f},{0xef,0xff,0xff},{0xff,0xef,0xff},{0xff,0xff,0xef},
	{0xff,0xff,0xff},{0xef,0x7f,0xff},{0x00,0x00,0xff},{0xff,0xff,0xef},
	{0x00,0xff,0xff},{0xef,0xff,0xff},{0xff,0xef,0xff},{0xff,0xff,0xef},
	{0xff,0x00,0xff},{0xef,0x1f,0xff},{0xff,0xef,0xff},{0xff,0xff,0xef},
	{0x00,0x21,0xff},{0xef,0xef,0x00},{0xff,0xe0,0x10},{0xff,0xef,0x0f},
	{0x00,0x00,0x00}};



int main(int argc, char * argv[])
{

	MANDELBROT mdl={ 2048, {{-1.5,-1.0},{.5,1.0}}, "mdl.bmp"};


	
		switch (argc)
		{
		case 7:
			sscanf(argv[6], "%lf", &mdl.reg.end.y);
		case 6:
			sscanf(argv[5], "%lf", &mdl.reg.end.x);
		case 5:
			sscanf(argv[4], "%lf", &mdl.reg.start.y);
		case 4:
			sscanf(argv[3], "%lf", &mdl.reg.start.x);
		case 3:
			sscanf(argv[2], "%hu",&mdl.resolution);
		case 2:
			mdl.filename=argv[1];
			break;
		default:
			fprintf(stderr, "%s:Usando valores por omissao\n", argv[0]);
		}
	printf("Using values: start.x = %lf start.y = %lf end.x = %lf end.y = %lf\n", mdl.reg.start.x, mdl.reg.start.y, mdl.reg.end.x, mdl.reg.end.y);
	compute(&mdl);
	return 0;
}

